//###########################################################################
//					tHƑw{eBNXw
//###########################################################################
//@"NoribMp"SCI֘AvO
//
// written by
//   2010/8/30 ikeda@E-Sys_Lab
//###########################################################################
#include "DSP28x_Project.h"
#include "SCI.h"
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <float.h>

volatile FIFO scififo;

void Init_SCI(Uint16 b, char *tbuf, Uint16 txl, char *rbuf, Uint16 rxl)
{
	Uint16 bl, bh;
	
	DINT;  // Disable interrupt
	
	bh = b >> 8;
	bl = b - (bh << 8);
	
	scififo.tx.buf = tbuf;
	scififo.rx.buf = rbuf;
	scififo.tx.maxlen = txl;
	scififo.rx.maxlen = rxl;
	scififo.rx.rp = scififo.rx.wp = 0;
	scififo.tx.rp = scififo.tx.wp = 0;
//	scififo.tx.maxlen = sizeof(tbuf);
//	scififo.rx.maxlen = sizeof(rbuf);
	
	EALLOW;  // Enable EALLOW protected register
	
	SysCtrlRegs.PCLKCR0.bit.SCIAENCLK = 1;
	
	PieVectTable.SCIRXINTA = &int_scirx;
	PieVectTable.SCITXINTA = &int_scitx;
	
	GpioCtrlRegs.GPAPUD.bit.GPIO28 = 0;    // Enable pull-up for GPIO28 (SCIRXDA)
	GpioCtrlRegs.GPAPUD.bit.GPIO29 = 0;	   // Enable pull-up for GPIO29 (SCITXDA)
	
	GpioCtrlRegs.GPAQSEL2.bit.GPIO28 = 3;  // Asynch input GPIO28 (SCIRXDA)

	GpioCtrlRegs.GPAMUX2.bit.GPIO28 = 1;   // Configure GPIO28 for SCIRXDA operation
	GpioCtrlRegs.GPAMUX2.bit.GPIO29 = 1;   // Configure GPIO29 for SCITXDA operation

	EDIS;  // Disable EALLOW protected register
	
	PieCtrlRegs.PIECTRL.bit.ENPIE = 1; // Enable the PIE block
	PieCtrlRegs.PIEIER9.all = 0x0003;  // Enable int9.1 and int9.2 in PIE
	IER |= M_INT9;  // Enable CPU interrupt 9
	EINT;  // Enable interrupt INTM
	ERTM;  // Enable realtime interrupt DBGM
	
	SciaRegs.SCICCR.bit.SCICHAR = 0x7;  // Character lengh is 8 bits
	SciaRegs.SCICTL1.all = 0x0003;  // Enable receiver and transmitter
	SciaRegs.SCICTL2.all = 0x0002;  // Enable RXRDY/BRKDT TXRDY interrupt
	
	SciaRegs.SCIHBAUD = bh;  // Set baudrate
	SciaRegs.SCILBAUD = bl;  // Set baudrate
	
	SciaRegs.SCICTL1.bit.SWRESET = 1;  // Relinquish SCI from Reset
	
//	EnableInterrupts();
}


// Transmit buffer check
int16 rs_tx_buff(void)
{
	int16 s;
	if ((s = (scififo.tx.rp - scififo.tx.wp)) <= 0) s += scififo.tx.maxlen;
	return s - 1;
}

// Receive buffer check
int16 rs_rx_buff(void)
{
	int16 s;
	if ((s = (scififo.rx.wp - scififo.rx.rp)) < 0) s += scififo.rx.maxlen;
	return s;
}

// One character transmit
void rs_putc(int16 buff)
{
	volatile int16 t;
	char c = (char)(buff & 0x00FF);
	
	t = (scififo.tx.wp + 1) % scififo.tx.maxlen;
	while (t == scififo.tx.rp){}
	scififo.tx.buf[scififo.tx.wp] = c;
	scififo.tx.wp = t;
//	SciaRegs.SCITXBUF = 0x0000;
	if(SciaRegs.SCICTL2.bit.TXRDY == 1){
		SciaRegs.SCITXBUF = scififo.tx.buf[scififo.tx.rp++];
		scififo.tx.rp %= scififo.tx.maxlen;
	}else{
		SciaRegs.SCICTL2.bit.TXINTENA = 1;
	}
//	SciaRegs.SCICTL1.bit.SWRESET = 1;
//	SciaRegs.SCICTL1.bit.TXENA = 1;
}

void rs_puts (char *st)
{
	while (*st) {
		rs_putc (*st);
		if (*st++ == '\n') rs_putc ('\r');
	}
}


int16 rs_printf (const char *format, ...)
{
	int16   i = 0;
	char    scratch[16], f, *ptr;
	Uint32  val = 0, base, buff;
	float   fval = 0.0f;
	char    ch, z, n, nn, l, c, m, fl;
	va_list ap;
	
	va_start (ap, format);
	for (;;) {
		while ((f = *format++) != '%') {
			if (!f) {
				va_end (ap);
				return i;
			} else {
				rs_putc (f);
				if (f == '\n') rs_putc ('\r');
				i++;
			}
		}
		c = 0;
		
		if (!(z = (f = *format++) == '0')) format--;
		
		f = *format++;
		if (f >= '1' && f <= '9') n = f - '0'; else {n = 0; format--;}
		if((f = *format++) == '.'){
			f = *format++;
			if (f >= '1' && f <= '9') nn = f - '0'; else {nn = 4; format--;}
		}else{
			format--;
			nn = 4;
		}
		
		f = *format++;
		l = (f == 'l');
		if (!l) format--;
		m = 0;
		fl = 0;
		
		switch (f = *format++) {
			case 'c':
				f = va_arg (ap, int);
				i++;
			default:
				rs_putc (f);
				continue;
			case 's':
				ptr = va_arg (ap, char *);
				rs_puts (ptr);
				i += strlen(ptr);
				continue;
			case 'o':
				val = (long)(l ? va_arg (ap, long) : va_arg (ap, int));
				base = 8L;
				goto CONV_LOOP;
			case 'd':
				if (l) {
					val = va_arg (ap, long);
					if (((long)val) < 0L) {
						m = 1;
						val = - val;
					}
				} else {
					val = va_arg (ap, int);
					if ((short)val < 0) {
						m = 1;
						val = - val;
					}
				}
				base = 10L;
				goto CONV_LOOP;
			case 'f':
				fval = (float)va_arg(ap, float);
				if((float)fval < 0.0f){
					m = 1;
					fval = - fval;
				}
				fl = 1;
				goto CONV_LOOP;
			case 'b':
				val = (long)(l ? va_arg (ap, long) : va_arg (ap, int));
				base = 2L;
				goto CONV_LOOP;
			case 'u':
				val = (long)(l ? va_arg (ap, long) : va_arg (ap, int));
				base = 10L;
				goto CONV_LOOP;
			case 'X':
				c = 1;
			case 'x':
				base = 16L;
				val = (long)(l ? va_arg (ap, long) : va_arg (ap, int));

			CONV_LOOP:
				for (i = 0; i < 16; i++) scratch[i] = z ? '0' : ' ';
				ptr = scratch + 16;
				*--ptr = 0;
				if(!fl){
					do {
						ch = (char)(val % base) + '0';
						if (ch > '9') ch += (c ? 'A' : 'a') - '9' - 1;
						*--ptr = ch;
						val /= base;
					} while (val);
				}else{
					buff = (unsigned long)fval;
					base = 1;
					for(i=0;i<nn;i++)base*=10;
					val = buff = (unsigned long)((fval - buff)*base);
					while (val) {
						ch = (char)(val % 10) + '0';
						*--ptr = ch;
						val /= 10;
					}
					if(buff){*--ptr = '.';}
					val = (unsigned long)fval;
					do {
						ch = (char)(val % 10) + '0';
						*--ptr = ch;
						val /= 10;
					} while (val);
				}
				if (m) *--ptr = '-';
				if (n) ptr = scratch + 15 - n;
				rs_puts (ptr);
				i += strlen(ptr);
		}
	}
}

// One character receive
unsigned char rs_getc(void)
{
	unsigned char c;

	while(scififo.rx.rp == scififo.rx.wp){}
	c = scififo.rx.buf[scififo.rx.rp++] & 0x00FF;
	scififo.rx.rp %= scififo.rx.maxlen;
	return c;
}


// Transmit interrupt
interrupt void int_scitx(void)
{
	if(scififo.tx.rp != scififo.tx.wp){
		SciaRegs.SCITXBUF = scififo.tx.buf[scififo.tx.rp++];
		scififo.tx.rp %= scififo.tx.maxlen;
	}else{
		SciaRegs.SCICTL2.bit.TXINTENA = 0;
//		SciaRegs.SCICTL1.bit.TXENA = 0;
	}
//	SciaRegs.SCIFFTX.bit.TXFFINTCLR = 1;  // Clear SCI Interrupt flag
	PieCtrlRegs.PIEACK.all = PIEACK_GROUP9;  // Acknowledge interrupt to PIE
}

// Receive interrupt
interrupt void int_scirx(void)
{
	volatile int16 t;
	Uint16 c = SciaRegs.SCIRXBUF.all;
	
	t = (scififo.rx.wp + 1) % scififo.rx.maxlen;
	scififo.rx.buf[scififo.rx.wp] = c;
	if(t != scififo.rx.rp) scififo.rx.wp = t;
	
//    SciaRegs.SCIFFRX.bit.RXFFOVRCLR=1;  // Clear Overflow flag
//    SciaRegs.SCIFFRX.bit.RXFFINTCLR=1;  // Clear Interrupt flag
	PieCtrlRegs.PIEACK.all = PIEACK_GROUP9;  // Acknowledge interrupt to PIE
}
