#ifndef SCI_H_
#define SCI_H_

#define br115200 0x000F
#define  br76800 0x0017
#define  br57600 0x0020
#define  br38400 0x002F
#define  br19200 0x0060

typedef struct{
	struct{
		char *buf;
		int16 wp;
		int16 rp;
		int16 maxlen;
	}tx;
	struct{
		char *buf;
		int16 wp;
		int16 rp;
		int16 maxlen;
	}rx;
}FIFO;

extern void Init_SCI(Uint16 b, char *tbuf, Uint16 txl, char *rbuf, Uint16 rxl);
extern int16 rs_tx_buff(void);
extern int16 rs_rx_buff(void);
extern void rs_putc(int16 c);
extern void rs_puts (char *st);
extern int16 rs_printf (const char *format, ...);
extern unsigned char rs_getc(void);
extern interrupt void int_scitx(void);
extern interrupt void int_scirx(void);

#endif /*SCI_H_*/
